com.amazon.redshift.hostchooser

## Enum HostRequirement

- java.lang.Object
- - java.lang.Enum<HostRequirement>
  - - com.amazon.redshift.hostchooser.HostRequirement

All Implemented Interfaces:
  Serializable, Comparable<HostRequirement>

    public enum HostRequirement
    extends Enum<HostRequirement>

Describes the required server type.

### Enum Constant Summary

Enum Constants
Enum Constant and Description
`any`
`master` Deprecated. we no longer use the terms master or slave in the driver, or the Redshift project.
`preferSecondary`
`primary`
`secondary`

### Method Summary

Methods
`abstract boolean` `allowConnectingTo(HostStatus status)`
`static HostRequirement` `getTargetServerType(String targetServerType)` The Redshift project has decided not to use the term slave to refer to alternate servers.
`static HostRequirement` `valueOf(String name)` Returns the enum constant of this type with the specified name.
`static HostRequirement[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Enum Constant Detail

#### any

    public static final HostRequirement any

#### master

    @Deprecated
    public static final HostRequirement master

Deprecated. we no longer use the terms master or slave in the driver, or the Redshift project.

#### primary

    public static final HostRequirement primary

#### secondary

    public static final HostRequirement secondary

#### preferSecondary

    public static final HostRequirement preferSecondary

### Method Detail

#### values

    public static HostRequirement[] values()

Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

    for (HostRequirement c : HostRequirement.values())
        System.out.println(c);

Returns:
  an array containing the constants of this enum type, in the order they are declared

#### valueOf

    public static HostRequirement valueOf(String name)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null

#### allowConnectingTo

    public abstract boolean allowConnectingTo(HostStatus status)

#### getTargetServerType

    public static HostRequirement getTargetServerType(String targetServerType)

The Redshift project has decided not to use the term slave to refer to alternate servers. secondary or standby is preferred. We have arbitrarily chosen secondary. As of Jan 2018 in order not to break existing code we are going to accept both slave or secondary for names of alternate servers.

The current policy is to keep accepting this silently but not document slave, or slave preferSlave

As of Jul 2018 silently deprecate the use of the word master as well

Parameters:
  `targetServerType` - the value of `targetServerType` connection property
Returns:
  HostRequirement